/*
 *	File:	Koliada - ast.h
 *
 *	Contains: Koliada AST header
 *
 * Edition: TINY
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  Copyright:	 1989-2012 by Guy McIlroy
 *  All rights reserved.
 *
 *  This module contains confidential, unpublished, proprietary source code.
 *  The copyright notice above does not evidence any actual or intended
 *  publication of such source code.
 *
 *  This code may only be used under licence from Koliada, LLC - www.koliada.com
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 */
#ifndef __AST_H
#define __AST_H

#include "object.h"
#include "action_config.h"	// bring in impelentation specific details

// AST (Asynchronous System Trap) are not supported in KoliadaES-TE
#error AST not supported in KoliadaES-TE

// ASTs assume the priority of the task they are posted to, in the order they are posted
// if there is no RTOS, then order only...

// createAst(a)					// create an AST
// deleteAst(a)					// delete an AST
// PostAst(a, ...)				// post an AST
// PostInt(a, ...)				// post an AST as an interrupt (goes to front of queue)
// TraceAst(name, trace)	   // turn tracing on for a specific AST or all ASTs (a=ANY)

#endif//__AST_H

