/*
 *	File:	Koliada - class.h
 *
 *	Contains: KoliadaES CLASS header
 *
 * Edition: TINY
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  Copyright  1989-2015 by Guy McIlroy
 *  All rights reserved.
 *
 *  This module contains confidential, unpublished, proprietary source code.
 *  The copyright notice above does not evidence any actual or intended
 *  publication of such source code.
 *
 *  This code may only be used under licence from Koliada, LLC - www.koliada.com
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 */
#ifndef __CLASS_H
#define __CLASS_H

// a class is an object describing a set of object instances

#include "object.h"	// class objects inherit from object

#ifndef __CLASS_STRUCT_H
	typedef object class;
#endif
#define kClassType "class"
#define kClassClass ((EVENT)kClassType)
#define kClassObjectSize (kObjectSize + 7)	// words (>excluding< object bit struct)

#define DefineClass(name) DefineObject(CLASS, "class", kClassObjectSize, name)
#define ExternClass(name) ExternObject(CLASS, name)

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef __CLASS_STRUCT_H									// external API

OBJECT classMethod(CLASS, word);                   // inherited class method
STATUS classInvoke(CLASS, word, ...);              // invoke inherited class method

#endif
#endif//__CLASS_H

