/*
 *	File:
 *
 *	Contains:
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  Copyright:	 1989-2012 by Guy McIlroy
 *  All rights reserved.
 *
 *  This module contains confidential, unpublished, proprietary source code.
 *  The copyright notice above does not evidence any actual or intended
 *  publication of such source code.
 *
 *  This code may only be used under licence from Koliada, LLC - www.koliada.com
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 */
#ifndef __CTYPE_H
#define __CTYPE_H
// http://www.opengroup.org/onlinepubs/000095399/basedefs/ctype.h.html
// simple ASCII version only
// does not use locale

extern const char __ctype_tab[];

#define  isalnum(x) (__ctype_tab[(x&127)+1]&0x07)
#define  isalpha(x) (__ctype_tab[(x&127)+1]&0x03)
#define  isascii(x) (((x)&0x80)==0)
#define  isblank(x) ((c)==' '||(c)=='\t')
#define  iscntrl(x) (__ctype_tab[(x&127)+1]&0x20)
#define  isdigit(x) (__ctype_tab[(x&127)+1]&0x04)
#define  isgraph(x) (__ctype_tab[(x&127)+1]&0x47)
#define  islower(x) (__ctype_tab[(x&127)+1]&0x02)
#define  isprint(x) (__ctype_tab[(x&127)+1]&0xc7)
#define  ispunct(x) (__ctype_tab[(x&127)+1]&0x40)
#define  isspace(x) (__ctype_tab[(x&127)+1]&0x10)
#define  isupper(x) (__ctype_tab[(x&127)+1]&0x01)
#define isxdigit(x) (__ctype_tab[(x&127)+1]&0x08)

#define toascii(x) ((x)&127)

int   tolower(int);
int   toupper(int);

#define _tolower(c) (isupper(c)?((c)|0x20):(c))
#define _toupper(c) (islower(c)?((c)&0x5f):(c))

#endif
