/*
 *	File: Koliada - sysGpio.h
 *
 *	Contains: system gpio defines
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  Copyright:	 1989-2012 by Guy McIlroy
 *  All rights reserved.
 *
 *  This module contains confidential, unpublished, proprietary source code.
 *  The copyright notice above does not evidence any actual or intended
 *  publication of such source code.
 *
 *  This code may only be used under licence from Koliada, LLC - www.koliada.com
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 */
#ifndef __SYSGPIO_H
#define __SYSGPIO_H

#include "BoardConfig.h"

// gpio functions
// these are only for pins declared in the BoardConfig pinTable

// Address indicies
#define INP_GPIO_ADDR 	0						// input address
#define OUT_GPIO_ADDR 	1						// output address
#define DIR_GPIO_ADDR 	2						// direction address
#define SEL_GPIO_ADDR 	3						// selection address
#define REN_GPIO_ADDR 	4						// resistor enable address
#define IFG_GPIO_ADDR 	5						// interrupt flag address
#define IER_GPIO_ADDR 	6						// interrupt enable address

PTR  sysGpioAddr(word pin, word index);	// get a pin register address
word sysGpioMask(word pin);					// get pin mask

#if 0 // use GPIO.XXX()
word sysGpioGET(word pin);						// get pin input state
word sysGpioSET(word pin, word set);		// set pin output state
word sysGpioXOR(word pin);						// xor (toggle) pin output state
word sysGpioDIR(word pin, word set);		// set pin direction (in/out)
word sysGpioSEL(word pin, word set);		// set pin function
word sysGpioREN(word pin, word set);		// enable pin resistor (pullup/pulldn/none)

word sysGpioINT(word pin);						// get pin interrupt flag state
word sysGpioIFG(word pin, word set);		// set pin interrupt flag state
word sysGpioIES(word pin, word set);		// set interrupt edge select bit
word sysGpioIEN(word pin, word set);		// set interrupt enable bit (clears the flag)
#endif

#define GPIO1  0
#define GPIO2  1
#define GPIO3  2
#define GPIO4  3
#define GPIO5  4
#define GPIO6  5
#define GPIO7  6
#define GPIO8  7
#define GPIO9  8
#define GPIO10 9

#if 0
#define GPIO_GET sysGpioGET
#define GPIO_SET sysGpioSET
#define GPIO_XOR sysGpioXOR
#define GPIO_DIR sysGpioDIR
#define GPIO_SEL sysGpioSEL
#define GPIO_REN sysGpioREN

#define GPIO_INT sysGpioINT
#define GPIO_IFG sysGpioIFG
#define GPIO_IES sysGpioIES
#define GPIO_IEN sysGpioIEN
#endif

#endif//__GPIO_H
