/*
 *	File: Koliada - ctypes.h
 *
 *	Contains: some basic (target variant) typedefs
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  Copyright  1989-2012 by Guy McIlroy
 *  All rights reserved.
 *
 *  This module contains confidential, unpublished, proprietary source code.
 *  The copyright notice above does not evidence any actual or intended
 *  publication of such source code.
 *
 *  This code may only be used under licence from Koliada, LLC - www.koliada.com
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 */
#ifndef __CTYPES_H
#define __CTYPES_H
#if __cplusplus
extern "C" {
#endif
// pulled in by typedefs.h

#if 0
#define __NAKED_ATTRIB__	__attribute__ ((naked))
#define NAKED					__NAKED_ATTRIB__
#define __PACKED_ATTRIB__	__attribute__ ((packed))
#define PACKED					__PACKED_ATTRIB__
#define WORD_ALIGN			__attribute__ ((aligned (4)))
#else
#define NAKED __noreturn
#endif

#define __sizeof_word 2

typedef void *PTR;
typedef void (*FPTR)();
typedef unsigned short SYSPTR;

#if 0
typedef signed char  BYTE;
typedef signed short BYTE2;
typedef signed int   BYTE4;

typedef unsigned char  UBYTE;
typedef unsigned short UBYTE2;
typedef unsigned int   UBYTE4;

typedef unsigned char	UINT8;
typedef unsigned short	UINT16;
typedef unsigned 			UINT32;
#endif

typedef signed char	Int8;
typedef signed short	Int16;
typedef signed long	Int32;

typedef unsigned char	UInt8;
typedef unsigned short	UInt16;
typedef unsigned long	UInt32;

typedef unsigned char	bits8_t;
typedef unsigned short	bits16_t;
typedef unsigned long	bits32_t;

typedef unsigned char	byte;		// 1
typedef unsigned short	wyde;		// 2
typedef unsigned long	teta;		// 4
#ifdef LONGLONG
	typedef unsigned long long	octa;		// 8
#else
	typedef unsigned long	octa[2];	// 8
#endif

typedef unsigned short word;	// optimal machine size!
typedef unsigned long dword;	// optimal long machine size!
//typedef unsigned size_t;

#ifndef HAVE_BOOLEAN
#define HAVE_BOOLEAN
#if !__cplusplus
		typedef signed char bool;
#endif

typedef bool boolean;
typedef bool BOOL;
typedef bool Bool;
typedef bool Boolean;
#endif
#if !__cplusplus
	#ifdef false
		#undef false
	#endif
	#define false ((bool)0)

	#ifdef true
		#undef true
	#endif
	#define true (!false)
#endif
#define TRUE  true
#define FALSE false

typedef unsigned	BitField;

typedef word   OBJECT;

typedef word	STACK_T;
typedef word	POINTER;
typedef word	REGISTER;
//typedef word PIXEL;

typedef word STATUS;

#ifndef __STATIC
	#define STATIC
	#define __STATIC
#endif

#ifndef __CONST
	#define CONST const
	#define __CONST
#endif

#ifndef __const_object__
	#define __const_object__ const
#endif

#ifndef LAMBDA
	#define LAMBDA		((void*)-1)
#endif
#ifndef NULL
	#define NULL		((void*)0)
#endif

#define OK		0
#define ERROR ((STATUS)-1)

#ifndef ANY
	#define ANY		((unsigned)-1)
#endif

#define __do(x) do { x } while (__LINE__ == -1)

#if 0
typedef char *LINKER_REF[];
extern LINKER_REF __DATA_SRC, __DATA_DST, __BSS_START, __SP_INIT, __SP_END, __FLASH_SRC, __FLASH_DST, __DATA_SIZE, __BSS_SIZE, __FLASH_SIZE;
#endif

// Generic hardware related stuff
#define BIT0 (0x01 << 0)
#define BIT1 (0x01 << 1)
#define BIT2 (0x01 << 2)
#define BIT3 (0x01 << 3)
#define BIT4 (0x01 << 4)
#define BIT5 (0x01 << 5)
#define BIT6 (0x01 << 6)
#define BIT7 (0x01 << 7)
#define BIT8 (0x01 << 8)
#define BIT9 (0x01 << 9)
#define BIT10 (0x01 << 10)
#define BIT11 (0x01 << 11)
#define BIT12 (0x01 << 12)
#define BIT13 (0x01 << 13)
#define BIT14 (0x01 << 14)
#define BIT15 (0x01 << 15)
#define BIT16 (0x01 << 16)
#define BIT17 (0x01 << 17)
#define BIT18 (0x01 << 18)
#define BIT19 (0x01 << 19)
#define BIT20 (0x01 << 20)
#define BIT21 (0x01 << 21)
#define BIT22 (0x01 << 22)
#define BIT23 (0x01 << 23)
#define BIT24 (0x01 << 24)
#define BIT25 (0x01 << 25)
#define BIT26 (0x01 << 26)
#define BIT27 (0x01 << 27)
#define BIT28 (0x01 << 28)
#define BIT29 (0x01 << 29)
#define BIT30 (0x01 << 30)
#define BIT31 (0x01 << 31)

// endian stuff
#define Swap16

//
//
//

#define B_0000 0
#define B_0001 1
#define B_0010 2
#define B_0011 3
#define B_0100 4
#define B_0101 5
#define B_0110 6
#define B_0111 7
#define B_1000 8
#define B_1001 9
#define B_1010 a
#define B_1011 b
#define B_1100 c
#define B_1101 d
#define B_1110 e
#define B_1111 f

#define _B2H(bits) B_##bits
#define B2H(bits) _B2H(bits)
#define _HEX(n) 0x##n##UL
#define HEX(n) _HEX(n)
#define _CCAT(a,b) a##b
#define CCAT(a,b) _CCAT(a,b)

#define BYTE(a,b) HEX( CCAT(B2H( a),B2H( b)) )
#define WORD(a,b,c,d) HEX( CCAT(CCAT(B2H( a),B2H( b)),CCAT(B2H( c),B2H( d))) )
#define DWORD(a,b,c,d,e,f,g,h) HEX( CCAT( CCAT(CCAT(B2H( a),B2H( b)),CCAT(B2H( c),B2H( d))),CCAT(CCAT(B2H( e),B2H( f)),CCAT(B2H( g),B2H( h))) ) )

/* usage examples
char b = BYTE(0100,0001);                                              // equivalent to b = 65; or b = 'A'; or b = 0x41;
unsigned int w = WORD(1101,1111,0100,0011);                            // equivalent to w = 57155; or w = 0xdf43;
unsigned long int dw = DWORD(1101,1111,0100,0011,1111,1101,0010,1000); // equivalent to dw = 3745774888; or dw = 0xdf43fd28;
*/

#if 0
#define HEX__(n) 0x##n##LU

/* 8-bit conversion function */
#define B8__(x) ((x&0x0000000FLU)?1:0) \
+((x&0x000000F0LU)?2:0) \
+((x&0x00000F00LU)?4:0) \
+((x&0x0000F000LU)?8:0) \
+((x&0x000F0000LU)?16:0) \
+((x&0x00F00000LU)?32:0) \
+((x&0x0F000000LU)?64:0) \
+((x&0xF0000000LU)?128:0)

/* *** user macros *** */

/* for upto 8-bit binary constants */
#define B8(d) ((unsigned char)B8__(HEX__(d)))

/* for upto 16-bit binary constants, MSB first */
#define B16(dmsb,dlsb) (((unsigned long)B8(dmsb)<< 8) + (unsigned long)B8(dlsb))


/* for upto 32-bit binary constants, MSB first */
#define B32(dmsb,db2,db3,dlsb) (((unsigned long)B8(dmsb)<<24) + ((unsigned long)B8(db2)<<16) + ((unsigned long)B8(db3)<< 8) + B8(dlsb))

/* Sample usage:
B8(01010101) = 85
B16(10101010,01010101) = 43605
B32(10000000,11111111,10101010,01010101) = 2164238933
*/
#endif


#if __cplusplus
}
#endif
#endif
