/*
 * File: serialLink.h
 *
 * Contains:
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 *  Copyright:	 1989-2012 by Guy McIlroy
 *  All rights reserved.
 *
 *  This module contains confidential, unpublished, proprietary source code.
 *  The copyright notice above does not evidence any actual or intended
 *  publication of such source code.
 *
 *  This code may only be used under licence from Koliada, LLC - www.koliada.com
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *
 */
#ifndef __SERIALLINK_H
#define __SERIALLINK_H

#define DEFAULT_BAUD ((UInt32)-1)	// uses default set in BoardConfig

// serialLink.c
void serialFlush();

int serialGetc(word port);								// obtain next byte, as an unsigned char converted to an int, from a serial port
int serialPutc(int c, word port);					// writes c (converted to an unsigned char) to serial port.
int serialPuts(char *s, word port);					// writes string *s, followed by a <newline>, to the serial port.
int serialGets(char *s, word len, word port);	// reads bytes from the standard input stream, stdin, into the array pointed to by s,
																// until a <newline> is read or an end-of-file condition is encountered.
																// Any <newline> is discarded and a null byte is placed immediately after the last byte read into the array.
int serialWrite(word port, byte *buf, word len);
int serialRead(word port, byte *buf, word len);

EVENT setSerialEvent(word port, EVENT e);			// set the rx ready event for a serial port

void serialInit(word port, UInt32 baud, EVENT rxReadyEvent);

#endif//__SERIALLINK_H
