#include "EtherDATA.h"
#include "adc.h"
#include "string.h"
#include "pindefs.h"
#include "battery.h"

#include "dbData.ddl.h"

#define BAT_SAMPLES             3
#define OUTLIER_THRESHOLD       5
int printf(const char *, ...);
void ledOn(word led, word delay);
word adc(byte spec);

UInt16 bat_timer_counter;
UInt16 bat_sample_counter;
UInt16 previous_value = 0;
UInt16 sample_set[BAT_SAMPLES];

DefineTimer(lowBatLEDTimer);
void lowBatLED(TIMER t)
	{
	ledOn(RED, 200);
	}

UInt16 batterySample()
	{
	UInt16 value = 0;

	//GPIO.SET(FREE_IO, 1);
	value = (adc(0x00 | 0x30 | 0x0f) >> 3); // VDD/3 ref

	//GPIO.SET(FREE_IO, 0);

	return value;
	}

UInt16 batteryCalc(UInt16 adc)
	{
	UInt16 percent = 0;

	if (adc >= 2870)
		{
		if (adc > 3476)
			{
			percent = 100;
			}
		else
			{
			percent = (2 * adc) / 107 + 35;
			}
		printf("value: %u\n", adc);
		}
	else // [MIN, MAX] : [0%, 88%]
		{
		if (adc < 2310)
			{
			percent = 0;
			}
		else
			{
			percent = (3 * adc) / 21 - 330;
			printf("value: %u\n", adc);
			}
		}

	/*    else if ( (adc < 2870) && (adc >= 2504)) // [MIN, MAX] : [36%, 88%]
	    {
	      percent = (3 * adc)/21 - 321;
	      printf("value: %u\n", adc);
	    }
	    else                                     // MAX 36%
	    {
	      if (adc < 2243)
	      {
	        percent = 0;
	      }
	      else
	      {
	      percent = ((adc - 2243) * 7 + 51) / 52;
	      }
	     printf("value: %u\n", adc);
	    }*/

	return percent;
	}

// define a battery sample timer
DefineTimer(batterySampleTimer);
void batterySampleTimerHandler(TIMER e, dbValue ref, UInt16 time)
	{
	bat_timer_counter ++;
	if (bat_timer_counter >= (2 * time))
		{
		word value = 0;
		bat_timer_counter = 0;
		UInt16 percent = 0;

		// use the adc to measure the battery condition
		value = batterySample();
		percent = batteryCalc(value);

		if (percent <= 20)
			{
			dbSet(ref, percent);
			memcpy(&previous_value, &percent, sizeof(percent));
			bat_sample_counter = 0;
			ledOn(RED, 200);
			//cmStartTimer(lowBatLEDTimer);
			}
		else if (abs(previous_value - percent) > 5)
			{
			dbSet(ref, percent);
			memcpy(&previous_value, &percent, sizeof(percent));
			bat_sample_counter = 0;
			}
		else
			{
			memcpy(&previous_value, &percent, sizeof(percent));
			bat_sample_counter ++;
			}

		if (bat_sample_counter >= 7)
			{
			dbSet(ref, percent);
			bat_sample_counter = 0;
			}


		printf("battery:%d % \n", percent);
		}
	}

#if 0
void initBattery()
	{
	bat_timer_counter = 0;
	// set up and start the battery sampling timer
	objectCreate(batterySampleTimer, kIntervalTimer, TICKS(30100));
	OnEvent(batterySampleTimer, (HANDLER) batterySampleTimerHandler);

	objectCreate(lowBatLEDTimer, kIntervalTimer, TICKS(1000));
	OnEvent(lowBatLEDTimer, (HANDLER) lowBatLED);

	cmStartTimer(batterySampleTimer, batteryValue, 1);

	dbPublish(batteryValue);
	}
#endif
