/**************************************************************************************************
  Filename:       hal_i2c.h
  Revised:        $Date: 2012-09-21 06:30:38 -0700 (Fri, 21 Sep 2012) $
  Revision:       $Revision: 31581 $

  Description:    HAL I2C API for the CC2541ST. It implements the I2C master only.

**************************************************************************************************/

#ifndef HAL_I2C_H
#define HAL_I2C_H

/* ------------------------------------------------------------------------------------------------
 *                                          Includes
 * ------------------------------------------------------------------------------------------------
 */
//#include "comdef.h"
	
	#include "Etherdata.h"
	#include <ioCC2541.h>
   #include "hal_defs.h"
/* ------------------------------------------------------------------------------------------------
 *                                          Constants
 * ------------------------------------------------------------------------------------------------
 */
#define HAL_I2C_SLAVE_ADDR_DEF           0x41

/* ------------------------------------------------------------------------------------------------
 *                                           Typedefs
 * ------------------------------------------------------------------------------------------------
 */
typedef enum
{
  i2cClock_123KHZ = 0x00,
  i2cClock_144KHZ = 0x01,
  i2cClock_165KHZ = 0x02,
  i2cClock_197KHZ = 0x03,
  i2cClock_33KHZ  = 0x80,
  i2cClock_267KHZ = 0x81,
  i2cClock_533KHZ = 0x82
} i2cClock_t;


/* ------------------------------------------------------------------------------------------------
 *                                       Global Functions
 * ------------------------------------------------------------------------------------------------
 */
void     I2C_WRITE(UInt8 X);
UInt8     I2C_READ(UInt8 X);
void     HalI2CInit(UInt8 address, i2cClock_t clockRate);
UInt8    HalI2CRead(UInt8 len, UInt8 *pBuf);
UInt8    HalI2CWrite(UInt8 len, UInt8 *pBuf);
void     HalI2CDisable(void);

#endif
/**************************************************************************************************
 */
