// comment
/* comment /* nested */ */
typedef struct
   {
    word addr ;
    signed char rssi ;
   } NeighborTable;

UInt8 batteryValue
	{
	description "current (uncalibrated) battery value";
	access readonly;

	units "/4096";
	}

byte accelValue
	{
	description "Tag's Accel Value: 1-drop, 2-door";
	access readonly;
	units "g";
	}

byte accelConfig
	{
	description "Accel's Config Value: 1-Drop, 2-Door, 3- Confirm";
	access readwrite;
	}


int humiValue[1]
	{
	description "Current Humidity Sensor Value";
	access readonly;

	units "% or deg";
	}
	
int tempValue[1]	//JON ADD
        {
        description "Current Temperature Sensor Value";
        access readonly;

        units "C";
        }	
		  
int pressValue[1]	//JON ADD
        {
        description "Current Pressure Sensor Value";
        access readonly;

        units "mbar";
        }	

string msgData[21]
	{
	description "SmartTag message data";
	access readwrite;
	}
        
UInt16 msgConfirm
      {
      description "Message Received!";
      access readwrite;
      }

byte gateway
      {
      description "Gateway ping";
      access readwrite;
      }

byte deviceType
	{
	description "Device Type";
        // 1 - station
        // 2 - tracker
        // 3 - badge
	access readonly;
	}
        
byte buttonData
      {
      description "button values";
      access readonly;
      }
        
string configValue[5]
        {
        description "Config Value (hardware to init)";
        access readwrite configRequest;
        }

NeighborTable rssiTable[8]
      {
      description "Variable containing NeighborTable";
      access readonly;
      }
       
byte led
	{
	description "Device LEDs 0 - red, 1 - green";
	access readwrite ledRequest;
	}
        
char logData[18]
      {
      description "Logger Data";
      // [1] - Temp
      // [2] - Humidity
      // [3] - Accel
      // [4] - Sample Number / Frequency
      // [5] - Mode
      access readonly;
      }
      
 char setlogData[18]
      {
      description "Logger Data";
      // [1] - Temp
      // [2] - Humidity
      // [3] - Accel
      // [4] - Sample Number / Frequency
      // [5] - Mode
      access readwrite;
      }