// Station.ddl.c
// Generated by kDLL on Monday, October 3, 2016 10:19:49 AM

#define TYPE_UNDEF     0
#define TYPE_REMOTE    1
#define TYPE_CHAR      2
#define TYPE_INT       3
#define TYPE_WORD      4
#define TYPE_BYTE      5
#define TYPE_WYDE      6
#define TYPE_TETA      7
#define TYPE_REAL      8
#define TYPE_STRINGREF 9
#define TYPE_STRINGBUF 10
#define TYPE_BOOL      11
#define TYPE_INT8      12
#define TYPE_INT16     13
#define TYPE_INT32     14
#define TYPE_UINT8     15
#define TYPE_UINT16    16
#define TYPE_UINT32    17
#define TYPE_GROUP     18
#define TYPE_ACCESS    19

#define readonly  20
#define writeonly 21
#define readwrite 22

typedef unsigned short word;
typedef unsigned char byte;
typedef unsigned short wyde;
typedef unsigned long teta;
typedef float real;
typedef char *string;
typedef signed char bool;
typedef signed char Int8;
typedef signed short Int16;
typedef signed int Int32;
typedef unsigned char UInt8;
typedef unsigned short UInt16;
typedef unsigned int UInt32;

typedef word STATUS;
typedef word OBJECT;

struct ddl_value_defn
   {
   void *value;
   byte type;
   byte size;
   byte count;
   char *ident;
   STATUS (*get)(OBJECT, bool, byte);
   STATUS (*set)(OBJECT, bool, byte);
   byte attributeCount;
   struct ddl_attribute const *const *attributeTable;
   };

struct ddl_value
   {
   const struct ddl_value_defn *defn;

   byte pad[9];
   };

struct ddl_attribute
   {
   byte type;
   char *ident;
   void const *value;
   };

typedef struct 
   {
word addr ;
signed char rssi ;
   } NeighborTable;
#define Type_NeighborTable 20

static UInt8 batteryValue_value;
static const char *const batteryValue_description_value = "current (uncalibrated) battery value";
static const struct ddl_attribute batteryValue_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &batteryValue_description_value,
   };

static const byte batteryValue_access_value = readonly;
static const struct ddl_attribute batteryValue_access_field =
   {
   TYPE_ACCESS,
   "access",
   &batteryValue_access_value,
   };

static const char *const batteryValue_units_value = "/4096";
static const struct ddl_attribute batteryValue_units_field =
   {
   TYPE_STRINGREF,
   "units",
   &batteryValue_units_value,
   };

static const struct ddl_attribute *const batteryValue_Attribute_Table[] =
   {
   &batteryValue_description_field,
   &batteryValue_access_field,
   &batteryValue_units_field,
   };

const struct batteryValueEnum
   {
   byte description;
   byte access;
   byte units;
   } batteryValueEnum = { 16, 17, 18, };

static const struct ddl_value_defn batteryValue_defn =
   {
   &batteryValue_value,
   TYPE_UINT8,
   sizeof(UInt8),
   0,
   "batteryValue",
   0,
   0,
   3,
   batteryValue_Attribute_Table,
   };
static struct ddl_value ddl_batteryValue =
   {
   &batteryValue_defn,
   };
const word batteryValue =(word) &ddl_batteryValue;

static byte accelValue_value;
static const char *const accelValue_description_value = "Tag's Accel Value: 1-drop, 2-door";
static const struct ddl_attribute accelValue_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &accelValue_description_value,
   };

static const byte accelValue_access_value = readonly;
static const struct ddl_attribute accelValue_access_field =
   {
   TYPE_ACCESS,
   "access",
   &accelValue_access_value,
   };

static const char *const accelValue_units_value = "g";
static const struct ddl_attribute accelValue_units_field =
   {
   TYPE_STRINGREF,
   "units",
   &accelValue_units_value,
   };

static const struct ddl_attribute *const accelValue_Attribute_Table[] =
   {
   &accelValue_description_field,
   &accelValue_access_field,
   &accelValue_units_field,
   };

const struct accelValueEnum
   {
   byte description;
   byte access;
   byte units;
   } accelValueEnum = { 16, 17, 18, };

static const struct ddl_value_defn accelValue_defn =
   {
   &accelValue_value,
   TYPE_BYTE,
   sizeof(byte),
   0,
   "accelValue",
   0,
   0,
   3,
   accelValue_Attribute_Table,
   };
static struct ddl_value ddl_accelValue =
   {
   &accelValue_defn,
   };
const word accelValue =(word) &ddl_accelValue;

static byte accelConfig_value;
static const char *const accelConfig_description_value = "Accel's Config Value: 1-Drop, 2-Door, 3- Confirm";
static const struct ddl_attribute accelConfig_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &accelConfig_description_value,
   };

static const byte accelConfig_access_value = readwrite;
static const struct ddl_attribute accelConfig_access_field =
   {
   TYPE_ACCESS,
   "access",
   &accelConfig_access_value,
   };

static const struct ddl_attribute *const accelConfig_Attribute_Table[] =
   {
   &accelConfig_description_field,
   &accelConfig_access_field,
   };

const struct accelConfigEnum
   {
   byte description;
   byte access;
   } accelConfigEnum = { 16, 17, };

static const struct ddl_value_defn accelConfig_defn =
   {
   &accelConfig_value,
   TYPE_BYTE,
   sizeof(byte),
   0,
   "accelConfig",
   0,
   0,
   2,
   accelConfig_Attribute_Table,
   };
static struct ddl_value ddl_accelConfig =
   {
   &accelConfig_defn,
   };
const word accelConfig =(word) &ddl_accelConfig;

static int humiValue_value[1];
static const char *const humiValue_description_value = "Current Humidity Sensor Value";
static const struct ddl_attribute humiValue_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &humiValue_description_value,
   };

static const byte humiValue_access_value = readonly;
static const struct ddl_attribute humiValue_access_field =
   {
   TYPE_ACCESS,
   "access",
   &humiValue_access_value,
   };

static const char *const humiValue_units_value = "% or deg";
static const struct ddl_attribute humiValue_units_field =
   {
   TYPE_STRINGREF,
   "units",
   &humiValue_units_value,
   };

static const struct ddl_attribute *const humiValue_Attribute_Table[] =
   {
   &humiValue_description_field,
   &humiValue_access_field,
   &humiValue_units_field,
   };

const struct humiValueEnum
   {
   byte description;
   byte access;
   byte units;
   } humiValueEnum = { 16, 17, 18, };

static const struct ddl_value_defn humiValue_defn =
   {
   &humiValue_value,
   TYPE_INT,
   sizeof(int),
   1,
   "humiValue",
   0,
   0,
   3,
   humiValue_Attribute_Table,
   };
static struct ddl_value ddl_humiValue =
   {
   &humiValue_defn,
   };
const word humiValue =(word) &ddl_humiValue;

static int tempValue_value[1];
static const char *const tempValue_description_value = "Current Temperature Sensor Value";
static const struct ddl_attribute tempValue_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &tempValue_description_value,
   };

static const byte tempValue_access_value = readonly;
static const struct ddl_attribute tempValue_access_field =
   {
   TYPE_ACCESS,
   "access",
   &tempValue_access_value,
   };

static const char *const tempValue_units_value = "C";
static const struct ddl_attribute tempValue_units_field =
   {
   TYPE_STRINGREF,
   "units",
   &tempValue_units_value,
   };

static const struct ddl_attribute *const tempValue_Attribute_Table[] =
   {
   &tempValue_description_field,
   &tempValue_access_field,
   &tempValue_units_field,
   };

const struct tempValueEnum
   {
   byte description;
   byte access;
   byte units;
   } tempValueEnum = { 16, 17, 18, };

static const struct ddl_value_defn tempValue_defn =
   {
   &tempValue_value,
   TYPE_INT,
   sizeof(int),
   1,
   "tempValue",
   0,
   0,
   3,
   tempValue_Attribute_Table,
   };
static struct ddl_value ddl_tempValue =
   {
   &tempValue_defn,
   };
const word tempValue =(word) &ddl_tempValue;

static int pressValue_value[1];
static const char *const pressValue_description_value = "Current Pressure Sensor Value";
static const struct ddl_attribute pressValue_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &pressValue_description_value,
   };

static const byte pressValue_access_value = readonly;
static const struct ddl_attribute pressValue_access_field =
   {
   TYPE_ACCESS,
   "access",
   &pressValue_access_value,
   };

static const char *const pressValue_units_value = "mbar";
static const struct ddl_attribute pressValue_units_field =
   {
   TYPE_STRINGREF,
   "units",
   &pressValue_units_value,
   };

static const struct ddl_attribute *const pressValue_Attribute_Table[] =
   {
   &pressValue_description_field,
   &pressValue_access_field,
   &pressValue_units_field,
   };

const struct pressValueEnum
   {
   byte description;
   byte access;
   byte units;
   } pressValueEnum = { 16, 17, 18, };

static const struct ddl_value_defn pressValue_defn =
   {
   &pressValue_value,
   TYPE_INT,
   sizeof(int),
   1,
   "pressValue",
   0,
   0,
   3,
   pressValue_Attribute_Table,
   };
static struct ddl_value ddl_pressValue =
   {
   &pressValue_defn,
   };
const word pressValue =(word) &ddl_pressValue;

static byte msgData_value[21];
static const char *const msgData_description_value = "SmartTag message data";
static const struct ddl_attribute msgData_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &msgData_description_value,
   };

static const byte msgData_access_value = readwrite;
static const struct ddl_attribute msgData_access_field =
   {
   TYPE_ACCESS,
   "access",
   &msgData_access_value,
   };

static const struct ddl_attribute *const msgData_Attribute_Table[] =
   {
   &msgData_description_field,
   &msgData_access_field,
   };

const struct msgDataEnum
   {
   byte description;
   byte access;
   } msgDataEnum = { 16, 17, };

static const struct ddl_value_defn msgData_defn =
   {
   &msgData_value,
   TYPE_STRINGBUF,
   sizeof(byte),
   21,
   "msgData",
   0,
   0,
   2,
   msgData_Attribute_Table,
   };
static struct ddl_value ddl_msgData =
   {
   &msgData_defn,
   };
const word msgData =(word) &ddl_msgData;

static UInt16 msgConfirm_value;
static const char *const msgConfirm_description_value = "Message Received!";
static const struct ddl_attribute msgConfirm_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &msgConfirm_description_value,
   };

static const byte msgConfirm_access_value = readwrite;
static const struct ddl_attribute msgConfirm_access_field =
   {
   TYPE_ACCESS,
   "access",
   &msgConfirm_access_value,
   };

static const struct ddl_attribute *const msgConfirm_Attribute_Table[] =
   {
   &msgConfirm_description_field,
   &msgConfirm_access_field,
   };

const struct msgConfirmEnum
   {
   byte description;
   byte access;
   } msgConfirmEnum = { 16, 17, };

static const struct ddl_value_defn msgConfirm_defn =
   {
   &msgConfirm_value,
   TYPE_UINT16,
   sizeof(UInt16),
   0,
   "msgConfirm",
   0,
   0,
   2,
   msgConfirm_Attribute_Table,
   };
static struct ddl_value ddl_msgConfirm =
   {
   &msgConfirm_defn,
   };
const word msgConfirm =(word) &ddl_msgConfirm;

static byte gateway_value;
static const char *const gateway_description_value = "Gateway ping";
static const struct ddl_attribute gateway_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &gateway_description_value,
   };

static const byte gateway_access_value = readwrite;
static const struct ddl_attribute gateway_access_field =
   {
   TYPE_ACCESS,
   "access",
   &gateway_access_value,
   };

static const struct ddl_attribute *const gateway_Attribute_Table[] =
   {
   &gateway_description_field,
   &gateway_access_field,
   };

const struct gatewayEnum
   {
   byte description;
   byte access;
   } gatewayEnum = { 16, 17, };

static const struct ddl_value_defn gateway_defn =
   {
   &gateway_value,
   TYPE_BYTE,
   sizeof(byte),
   0,
   "gateway",
   0,
   0,
   2,
   gateway_Attribute_Table,
   };
static struct ddl_value ddl_gateway =
   {
   &gateway_defn,
   };
const word gateway =(word) &ddl_gateway;

static byte deviceType_value;
static const char *const deviceType_description_value = "Device Type";
static const struct ddl_attribute deviceType_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &deviceType_description_value,
   };

static const byte deviceType_access_value = readonly;
static const struct ddl_attribute deviceType_access_field =
   {
   TYPE_ACCESS,
   "access",
   &deviceType_access_value,
   };

static const struct ddl_attribute *const deviceType_Attribute_Table[] =
   {
   &deviceType_description_field,
   &deviceType_access_field,
   };

const struct deviceTypeEnum
   {
   byte description;
   byte access;
   } deviceTypeEnum = { 16, 17, };

static const struct ddl_value_defn deviceType_defn =
   {
   &deviceType_value,
   TYPE_BYTE,
   sizeof(byte),
   0,
   "deviceType",
   0,
   0,
   2,
   deviceType_Attribute_Table,
   };
static struct ddl_value ddl_deviceType =
   {
   &deviceType_defn,
   };
const word deviceType =(word) &ddl_deviceType;

static byte buttonData_value;
static const char *const buttonData_description_value = "button values";
static const struct ddl_attribute buttonData_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &buttonData_description_value,
   };

static const byte buttonData_access_value = readonly;
static const struct ddl_attribute buttonData_access_field =
   {
   TYPE_ACCESS,
   "access",
   &buttonData_access_value,
   };

static const struct ddl_attribute *const buttonData_Attribute_Table[] =
   {
   &buttonData_description_field,
   &buttonData_access_field,
   };

const struct buttonDataEnum
   {
   byte description;
   byte access;
   } buttonDataEnum = { 16, 17, };

static const struct ddl_value_defn buttonData_defn =
   {
   &buttonData_value,
   TYPE_BYTE,
   sizeof(byte),
   0,
   "buttonData",
   0,
   0,
   2,
   buttonData_Attribute_Table,
   };
static struct ddl_value ddl_buttonData =
   {
   &buttonData_defn,
   };
const word buttonData =(word) &ddl_buttonData;

static byte configValue_value[5];
static const char *const configValue_description_value = "Config Value (hardware to init)";
static const struct ddl_attribute configValue_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &configValue_description_value,
   };

static const byte configValue_access_value = readwrite;
static const struct ddl_attribute configValue_access_field =
   {
   TYPE_ACCESS,
   "access",
   &configValue_access_value,
   };

static const struct ddl_attribute *const configValue_Attribute_Table[] =
   {
   &configValue_description_field,
   &configValue_access_field,
   };

const struct configValueEnum
   {
   byte description;
   byte access;
   } configValueEnum = { 16, 17, };

STATUS configRequest(OBJECT, bool, byte);
STATUS configRequest(OBJECT, bool, byte);
static const struct ddl_value_defn configValue_defn =
   {
   &configValue_value,
   TYPE_STRINGBUF,
   sizeof(byte),
   5,
   "configValue",
   &configRequest,
   &configRequest,
   2,
   configValue_Attribute_Table,
   };
static struct ddl_value ddl_configValue =
   {
   &configValue_defn,
   };
const word configValue =(word) &ddl_configValue;

static NeighborTable rssiTable_value[8];
static const char *const rssiTable_description_value = "Variable containing NeighborTable";
static const struct ddl_attribute rssiTable_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &rssiTable_description_value,
   };

static const byte rssiTable_access_value = readonly;
static const struct ddl_attribute rssiTable_access_field =
   {
   TYPE_ACCESS,
   "access",
   &rssiTable_access_value,
   };

static const struct ddl_attribute *const rssiTable_Attribute_Table[] =
   {
   &rssiTable_description_field,
   &rssiTable_access_field,
   };

const struct rssiTableEnum
   {
   byte description;
   byte access;
   } rssiTableEnum = { 16, 17, };

static const struct ddl_value_defn rssiTable_defn =
   {
   &rssiTable_value,
   Type_NeighborTable,
   sizeof(NeighborTable),
   8,
   "rssiTable",
   0,
   0,
   2,
   rssiTable_Attribute_Table,
   };
static struct ddl_value ddl_rssiTable =
   {
   &rssiTable_defn,
   };
const word rssiTable =(word) &ddl_rssiTable;

static byte led_value;
static const char *const led_description_value = "Device LEDs 0 - red, 1 - green";
static const struct ddl_attribute led_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &led_description_value,
   };

static const byte led_access_value = readwrite;
static const struct ddl_attribute led_access_field =
   {
   TYPE_ACCESS,
   "access",
   &led_access_value,
   };

static const struct ddl_attribute *const led_Attribute_Table[] =
   {
   &led_description_field,
   &led_access_field,
   };

const struct ledEnum
   {
   byte description;
   byte access;
   } ledEnum = { 16, 17, };

STATUS ledRequest(OBJECT, bool, byte);
STATUS ledRequest(OBJECT, bool, byte);
static const struct ddl_value_defn led_defn =
   {
   &led_value,
   TYPE_BYTE,
   sizeof(byte),
   0,
   "led",
   &ledRequest,
   &ledRequest,
   2,
   led_Attribute_Table,
   };
static struct ddl_value ddl_led =
   {
   &led_defn,
   };
const word led =(word) &ddl_led;

static char logData_value[18];
static const char *const logData_description_value = "Logger Data";
static const struct ddl_attribute logData_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &logData_description_value,
   };

static const byte logData_access_value = readonly;
static const struct ddl_attribute logData_access_field =
   {
   TYPE_ACCESS,
   "access",
   &logData_access_value,
   };

static const struct ddl_attribute *const logData_Attribute_Table[] =
   {
   &logData_description_field,
   &logData_access_field,
   };

const struct logDataEnum
   {
   byte description;
   byte access;
   } logDataEnum = { 16, 17, };

static const struct ddl_value_defn logData_defn =
   {
   &logData_value,
   TYPE_CHAR,
   sizeof(char),
   18,
   "logData",
   0,
   0,
   2,
   logData_Attribute_Table,
   };
static struct ddl_value ddl_logData =
   {
   &logData_defn,
   };
const word logData =(word) &ddl_logData;

static char setlogData_value[18];
static const char *const setlogData_description_value = "Logger Data";
static const struct ddl_attribute setlogData_description_field =
   {
   TYPE_STRINGREF,
   "description",
   &setlogData_description_value,
   };

static const byte setlogData_access_value = readwrite;
static const struct ddl_attribute setlogData_access_field =
   {
   TYPE_ACCESS,
   "access",
   &setlogData_access_value,
   };

static const struct ddl_attribute *const setlogData_Attribute_Table[] =
   {
   &setlogData_description_field,
   &setlogData_access_field,
   };

const struct setlogDataEnum
   {
   byte description;
   byte access;
   } setlogDataEnum = { 16, 17, };

static const struct ddl_value_defn setlogData_defn =
   {
   &setlogData_value,
   TYPE_CHAR,
   sizeof(char),
   18,
   "setlogData",
   0,
   0,
   2,
   setlogData_Attribute_Table,
   };
static struct ddl_value ddl_setlogData =
   {
   &setlogData_defn,
   };
const word setlogData =(word) &ddl_setlogData;

