// comment
/* comment /* nested */ */
typedef struct
   {
    word addr ;
    signed char rssi ;
   } NeighborTable;

UInt8 batteryValue
	{
	description "Current (uncalibrated) battery value";
	access readonly;

	units "%";
	}

byte accelValue
        {
        description "Tag's Accel Value: 1-drop, 2-door";
        access readonly;

        units "unit of g";
        }

byte accelConfig
        {
        description "Accel's Config Value: 1-Drop, 2-Door, 3-Confirm";
        access readwrite accConfigChanged;
        }

int humiValue[3]
        {
        description "Current Humidity Sensor Value";
        access readonly;

        units "% or deg";
        }

byte deviceType
       {
       description "Device Type";
       // 1 - Station
       // 2 - Tracker
       // 3 - Badge
       access readonly;
       }

string configValue[5]
       {
       description "Config Value (hardware to init)";
       access readwrite configRequest;
       }

NeighborTable rssiTable[8]
      {
      description "Variable containing NeighborTable";
      access readonly;
      }

byte led
      {
      description "Device LEDs 0 - red, 1 - green";
      access readwrite ledRequest;
      }

UInt16 pthTimer
      {
      description "PTH sample timer (seconds)";
      access readwrite pthTimerRequest;
      }

UInt16 rssiTimer
      {
      description "Time interval to Publish neighborTable";
      access readwrite rssiTimerChanged;
      }

 char logData[17]
      {
      description "Logger Data";
      // [1] - Temp
      // [2] - Humidity
      // [3] - Accel
      // [4] - Sample Number / Frequency
      // [5] - Mode
      access readwrite logRequest;
      }

