#ifndef __LED_H
#define __LED_H

#include "EtherDATA.h"
// LED numbers
#define LED_RED 0	// virtual LED pin
#define LED_GRN 1
#define LED_BOTH 2

typedef const struct flash
	{
	byte led; 	// led select
	int  period;	// ms
	int delay;
	struct
		{
		byte enable	: 1; // enable output
		};
	} Flash;

// a tune is a collection of notes repeated N times
typedef const struct pattern
	{
	int repeats;
	byte flashCount;
	Flash *flash;
	} PatternDecl;
typedef PatternDecl *const Pattern;

void ledPWM(byte led, int delay);
extern Pattern redFlashPattern;
extern Pattern redFlashDimPattern;
extern Pattern greenFlashPattern;
extern Pattern greenFlashDimPattern;
extern Pattern yellowFlashPattern;
extern Pattern orangeFlashPattern;
extern Pattern nullPattern;

#endif//__LED_H