#include "EtherDATA.h"
#include "pCache.h"
#include "kNode.ddl.h"
#include "PHT Drivers.h"
#include "string.h"
#include "hal_i2c.h"

#include "TCA6416A.h"

int printf(const char *, ...);
double calcHumRel(UInt16 rawH);
double calcHumTmp(UInt16 rawT);
UInt8 HalI2CWrite(UInt8 len, UInt8 *pBuf);
void timerX(TIMER t, dbValue ref, UInt16 time);
UInt16 humi_sample_counter;
UInt16 humi_timer_counter;
double calcTemp();
double *calcPres();
double *calcTempPress();
void Sensor_Pwr(bool option);
void Sensor_Select(int sensor);
int humiState = 0;
int Humid[1];
int Temp[1]; //JON ADD
int Press[1];//JON ADD
int delCompare(void *key, void *buf, SIZE_T size);
UInt8 D1[24];
UInt8 D2[24];
//JON ADD
UInt16 temp_sample_counter;
UInt16 temp_timer_counter;
UInt16 press_sample_counter;
UInt16 press_timer_counter;
//JON STOP
// Length of sensor data in bytes
#define HUMIDITY_DATA_LEN               4
#define kTempType         kFirstpCacheType + 1		// cached record type
#define kHumiType         kFirstpCacheType + 2		// cached record type
#define kHumiSampleInterval 	TICKS(30000)	// ms
//#define kHumiSampleInterval 	TICKS(10000)	// ms
//#define kHumiSampleInterval 	TICKS(5000)	// ms
//#define kHumiSampleInterval 	TICKS(3000)	// ms
#define kTempSampleInterval 	TICKS(15000)	// ms
#define kPressSampleInterval 	TICKS(30000)	// ms



//JON START
int sampleTemp() // function to sample temp from sensor
	{
	unsigned long tData;
	//long Temp;
	//long Pressure;

	static int data;

	// need the i/o expander to stay awake
	waitExpander();

	SensorInit();
	cmDelayMs(20);


	TempMeasurementStep();

	TempReadMeasurement(&tData);

	// done with i/o expander
	postExpander();

	double values[1];
	memcpy(values, calcTempPress(), sizeof(values));
	debug("T=%d.%u\n", (int) values[0], (word) ((values[0] - (int) values[0]) * 100));

	data = (int) values[0];
	

	//Temp = values[0];
	//Pressure = values[1];

	// HalI2CDisable();
	return data;
	}

int samplePress() // function to sample pressure from sensor
	{
	unsigned long pData;


	static int data;

	// need the i/o expander to stay awake
	waitExpander();

	SensorInit();
	cmDelayMs(20);

	
	PressureMeasurementStep();

	PresReadMeasurement(&pData);

	// done with i/o expander
	postExpander();

	double values[1];
	memcpy(values, calcPres(), sizeof(values));
	debug("P=%d.%u\n", (int) values[0], (word) ((values[0] - (int) values[0]) * 100));

	data = (int) values[0];

	//Temp = values[0];
	//Pressure = values[1];

	// HalI2CDisable();
	return data;
	}

//JON STOP

int sampleHumiTemp() // function to sample temp, humi, and pressure from sensor
	{
	UInt8 hData[HUMIDITY_DATA_LEN];
	//unsigned long pData;
	//unsigned long tData;
	//long Temp;
	//long Pressure;
	UInt16 humid_MSB;
	UInt16 humid_LSB;
	UInt16 rawHumid;
	static int data;
	double rh = 0.0;

	// need the i/o expander to stay awake
	waitExpander();

	SensorInit();
	cmDelayMs(20);

	humi_sample_counter = 0;

	while (humiState < 2)
		{
		HumiExecMeasurementStep(humiState);
		humiState++;
		}

	if (humiState == 2)
		{
		if (HumiReadMeasurement(hData))
			{
			humid_LSB = hData[2];
			humid_MSB = hData[3] << 8;
			rawHumid = (humid_LSB | humid_MSB);
			rh = calcHumRel(rawHumid);
			}
		humiState = 0;
		}

	//PressureMeasurementStep();

	//PresReadMeasurement(&pData);

	//TempMeasurementStep();

	//TempReadMeasurement(&tData);

	// done with i/o expander
	postExpander();

	//double values[2];
	//memcpy(values, calcTempPress(), sizeof(values));
	//debug("P=%d.%u\n", (int) values[1], (word) ((values[1] - (int) values[1]) * 100));
	debug("H=%d.%u\n", (int) rh, (word) ((rh - (int) rh) * 100));
	//debug("T=%d.%u\n", (int) values[0], (word) ((values[0] - (int) values[0]) * 100));

	//data[0] = (int) values[0];
	data = (int) rh;
	//data[2] = (int) values[1];

	//Temp = values[0];
	//Pressure = values[1];

	// HalI2CDisable();
	return data;
	}

// define a humi sample timer
DefineTimer(humiSampleTimer);
void humiSampleTimerHandler(TIMER e, dbValue ref, UInt16 time)
	{
//	string desc;
//	string unit;

	humi_sample_counter ++;
	humi_timer_counter ++;

	//if (humi_sample_counter >= (1))//30 = every 15 min
		{
		humi_timer_counter = 0;

		// sample the data
		dbSet(humiValue, sampleHumiTemp());

	//	dbGetAttribute(ref, humiValueEnum.units, &unit);
	//	dbGetAttribute(ref, humiValueEnum.description, &desc);
		dbGet(humiValue, Humid);
		printf("Humi: %d\n", Humid[0]);	//JON CHANGED FROM HTP TO THP
		}
	}

//JON ADD
// define a temp sample timer
DefineTimer(tempSampleTimer);
void tempSampleTimerHandler(TIMER e, dbValue ref, UInt16 time)
	{
//	string desc;
//	string unit;

	temp_sample_counter ++;
	temp_timer_counter ++;

	if (temp_sample_counter >= (4))//30 = every 15 min
		{
		temp_timer_counter = 0;

		// sample the data
		dbSet(tempValue, sampleTemp());

	////	dbGetAttribute(ref, humiValueEnum.units, &unit);
	////	dbGetAttribute(ref, humiValueEnum.description, &desc);
		dbGet(tempValue, Temp);
		printf("Temp:%d\n", Temp[0]);
		}
	}

// define a press sample timer
DefineTimer(pressSampleTimer);
void pressSampleTimerHandler(TIMER e, dbValue ref, UInt16 time)
	{
//	string desc;
//	string unit;

	press_sample_counter ++;
	press_timer_counter ++;
	
	//if (press_sample_counter >= (4))//30 = every 15 min
		{
		press_timer_counter = 0;
		press_sample_counter = 0;
		// sample the data
		dbSet(pressValue, samplePress());

	////	dbGetAttribute(ref, humiValueEnum.units, &unit);
	////	dbGetAttribute(ref, humiValueEnum.description, &desc);
		dbGet(pressValue, Press);
		printf("Pressure:%d\n", Press[0]);
		}
	}
//JON STOP

void initHumi() // creates sample timer, resets counters, reads PROM data
	{
	humi_sample_counter = 0;
	humi_timer_counter = 0;

	temp_sample_counter = 0;
	temp_timer_counter = 0;
	
	press_sample_counter = 0;
	press_timer_counter = 0;
	// set up and start the humidity sampling timer
//	objectCreate(humiSampleTimer, kIntervalTimer, kHumiSampleInterval);// once per second
//	OnEvent(humiSampleTimer, (HANDLER) humiSampleTimerHandler);

	//JON ADD
//	objectCreate(tempSampleTimer, kIntervalTimer, kTempSampleInterval);// once per second
//	OnEvent(tempSampleTimer, (HANDLER) tempSampleTimerHandler);
	
	objectCreate(pressSampleTimer, kIntervalTimer, kPressSampleInterval);// once per second
	OnEvent(pressSampleTimer, (HANDLER) pressSampleTimerHandler);
	//JON STOP
	
	// need the i/o expander to stay awake
	waitExpander();

	// init the driver
	SensorInit();

	for (int i = 0; i < 8; i ++) // upon reset we need to retreive PROM data from sensor
		{
		Sensor_Prom(i);
		//cmSetTimer(humiDelayTimer, TICKS(20));
		//cmStartTimer(humiDelayTimer);
		}
	//humi_sample_counter = 30;
	//humiSampleTimerHandler(humiSampleTimer, humiValue, 0);

	// done with i/o expander
	postExpander();
			// debug
	/*while (1)
		{
		dbSet(tempValue, sampleTemp());
		cmDelayMs(10000);
		}
	*/
	}

void start_Humi() // publishes humiValue and starts sample timer
	{
	humi_sample_counter = 0;
	humi_timer_counter = 0;
	temp_sample_counter = 0;	//JON ADD
	temp_timer_counter = 0;		//JON ADD
	press_sample_counter = 0;	//JON ADD
	press_timer_counter = 0;		//JON ADD
	// publish the data
	//dbPublish(humiValue);
	//dbPublish(tempValue);	//JON ADD
	dbPublish(pressValue);	//JON ADD
	
	//cmStartTimer(humiSampleTimer, humiValue, 1);
//	cmDelayMs(500); //JON ADD
//	cmStartTimer(tempSampleTimer, tempValue, 1);	//JON ADD
	cmDelayMs(500);
	cmStartTimer(pressSampleTimer, tempValue, 1);	//JON ADD

	}

void termHumi() // withdraws humiValue and stops sample timer
	{
	dbWithdraw(humiValue);
	cmStopTimer(humiSampleTimer);
	//dbWithdraw(tempValue);	//JON ADD
	//cmStopTimer(tempSampleTimer);	//JON ADD
	//dbWithdraw(pressValue);	//JON ADD
	//cmStopTimer(pressSampleTimer);	//JON ADD
	}
