#ifndef __BUZZER_H
#define __BUZZER_H

#include "EtherDATA.h"

// a note is a frequency played for a duration
// note frequency is defined by the prescaler and compare values
typedef const struct note
	{
	byte prescaler; 	// prescalar value
	byte compare;		// compare value
	int  duration;		// ms
	struct
		{
		byte enable	: 1; // enable output
		};
	} Note;

// a tune is a collection of notes repeated N times
typedef const struct tune
	{
	byte repeats;
	byte noteCount;
	Note *note;
	} TuneDecl;
typedef TuneDecl *const Tune;

// some defined tunes (in buzzer.c)
extern Tune initTune;
extern Tune beepLo;
extern Tune beepHi;
extern Tune beepNIL;
extern Tune findTune;
extern Tune msgTune;

// Function prototypes
void initBuzzer();
void playTune(Tune tune);
void stopBuzzer();

// there is only one 'tune timer'
// this means only one tune can be played at a time...

#endif//__BUZZER_H
