#include "pCache.h"

#define kAccelType        kFirstpCacheType		// cached record type
#define kTempType         kFirstpCacheType + 1		// cached record type
#define kHumiType         kFirstpCacheType + 2		// cached record type
#define kConfigType       kFirstpCacheType + 3		// cached record type
#define kdataLogType      kFirstpCacheType + 4
#define kdataLogCounterType kFirstpCacheType + 5

#define TEST_ADDR 0x20000
#define PCACHE_ADDR ((ROMPTR) 0xB000)
#define NUM_PAGES 4
#define PAGE_SIZE 2048
#define NUM_RESERVE 1

void *cache = (void *) PCACHE_ADDR;

struct TEMP
	{
	UInt8 id;
	char json[2];
	};

struct LOG
	{
	UInt16 data;
	};

int msgCompare(void *key, void *buf, SIZE_T size)
	{
	char id = *(UInt8 *)key + 0x30;
	struct TEMP *tmp = buf;
	return ((long) id - (long) tmp->id);
	}


int delCompare(void *key, void *buf, SIZE_T size)
	{
	return 0;
	}


int lastSampleCompare(void *key, void *buf, SIZE_T size)
	{
	return 0;
	}

int dataLogCompare(void *key, void *buf, SIZE_T size)
	{
	UInt16 id = *(UInt16 *)key;
	struct LOG *dat = buf;
	return ((long) id - (long) dat->data);
	}

boolean checkFlush(wyde type, void *buf, SIZE_T size)
	{
	// called when a block is about to be flushed
	switch (type)
		{
		case kAccelType:
			return 0;           // no, we can flush these... for now
		case kTempType:
			return 0;	        // no, we can flush these
		case kHumiType:
			return 0;	        // no, we can flush these
		case kdataLogType:
			return 1;
		}
	return 0;	// keep everything else
	}

void initPCACHE(void)
	{
	//pCacheInit(cache, NUM_PAGES, PAGE_SIZE, NUM_RESERVE, checkFlush, true);
	pCacheInit(cache, NUM_PAGES, PAGE_SIZE, NUM_RESERVE, checkFlush, false);
	}