// comment
/* comment /* nested */ */
typedef struct
   {
    word addr ;
    signed char rssi ;
   } NeighborTable;

UInt8 batteryValue
	{
	description "Current (uncalibrated) battery value";
	access readonly;

	units "%";
	}

byte accelValue
        {
        description "Tag's Accel Value: 1-drop, 2-door";
        access readonly;

        units "unit of g";
        }

byte accelConfig
        {
        description "Accel's Config Value: 1-Drop, 2-Door, 3- Confirm";
        access readwrite accConfigChanged;
        }

int humiValue
        {
        description "Current Humidity Sensor Value";
        access readonly;

        units "% or deg";
        }
		  
int tempValue	//JON ADD
        {
        description "Current Temperature Sensor Value";
        access readonly;

        units "C";
        }	
		  
int pressValue	//JON ADD
        {
        description "Current Pressure Sensor Value";
        access readonly;

        units "mbar";
        }	
		
byte deviceType
       {
       description "Device Type";
       // 1 - Station
       // 2 - Tracker
       // 3 - Badge
       access readonly;
       }
       
byte buttonData
      {
      description "button values";
      access readonly;
      }
       
string configValue[5]
       {
       description "Config Value (hardware to init)";
       access readwrite configRequest;
       }
     
NeighborTable rssiTable[8]
      {
      description "Variable containing NeighborTable";
      access readonly;
      }
      
byte led
      {
      description "Device LEDs 0 - red, 1 - green";
      access readwrite ledRequest;
      }
      
byte gateway
      {
      description "Gateway ping";
      access readonly;
      }
      
 char logData[18]
      {
      description "Logger Data";
      // [1] - Temp
      // [2] - Humidity
      // [3] - Accel
      // [4] - Sample Number / Frequency
      // [5] - Mode
      access readonly;
      }
      
 char setlogData[18]
      {
      description "Logger Data";
      // [1] - Temp
      // [2] - Humidity
      // [3] - Accel
      // [4] - Sample Number / Frequency
      // [5] - Mode
      access readwrite logRequest;
      }
         